package WebFlow.edys;

import WebFlow.event.*;
import WebFlow.*;
import java.net.*;
import java.io.*;
import java.util.*;

import org.omg.CORBA.*;

public class runEdysImp extends WebFlow.BeanContextChildSupport
    implements runEdysOperations {

Calendar endEvent, startEvent, dayOne, defaultEnd;
long dayOneTime;
int StartDay, DayDiff;
long edysend;
int param3, param4;
int bytes_read;
boolean flag;  //true if more event follows
boolean first; //true if end_of_event date is 1111; no *.edy files
String msg_;
org.omg.CORBA.Object peer;
PropertyChangeSupport pcs;
String StatFileURL, OptionsFile, ContentsFile, ContentsFileURL;
String EdysInDir, FileBaseURL;
String EdysExec;
String OutContents; 
String EdysOutDir, OutFileBase;
int itxt;

public runEdysImp(org.omg.CORBA.Object peer, String msg)
   throws WebFlow.NullPointerException
  {
    super(peer);	
    msg_ = msg;
    pcs = new PropertyChangeSupport(peer,this);
    this.peer = peer;
    flag=true;
    /* installation constants */
    StatFileURL="http://aga.npac.syr.edu:8001/toEDYS/lms_stat.txt";
    ContentsFileURL="http://aga.npac.syr.edu:8001/toEDYS/contents.txt";
    FileBaseURL="http://aga.npac.syr.edu:8001/toEDYS/";
    OptionsFile="C:\\edyswwes\\e-input\\options.txt";
    EdysInDir="C:\\edyswwes\\e-input\\";
    EdysOutDir="C:\\edyswwes\\e-output\\";
    ContentsFile="C:\\edyswwes\\contents.txt";     
    EdysExec = "C:\\edyswwes\\edys2.exe";
    OutFileBase = "D:\\Jigsaw\\Jigsaw\\WWW\\fromEDYS\\";
    OutContents = OutFileBase + "contents.txt";     
  }

    public void setEDYS(String Message) {
     System.out.println("EDYSend: "+Message);
     edysend = Long.parseLong(Message);
    }

    public void setPRM3(String Message) {
     System.out.println("Param 3: "+Message);
     param3 = Integer.parseInt(Message);
    }

    public void setPRM4(String Message) {
     System.out.println("Param 4: "+Message);
     param4 = Integer.parseInt(Message);
    }



    public void run() {

     System.out.println("run is called...");
     try { 
      Process p = Runtime.getRuntime().exec(EdysExec);
      p.waitFor();
     }
     catch (Exception e) {System.out.println("EDYS Error: "+e.toString());}
      
     if(flag) {
       sendData(); 
       EdysDoneImp ev = new EdysDoneImp(peer,"http://whatever.com", "lms");
       pcs.fireEvent("EdysDone",ev);
     }  
    }

    public void receiveData() {
       System.out.println("event casc2dDone received!");
       first = receiveStat(param3,param4,edysend);
       receiveEDY();
       System.out.println("---------->FLAG: "+flag); 
       run();
    }

    boolean receiveStat(int param3, int param4, long edysend) {
    boolean start = false;
    boolean last  = false;

    // set deafault for edysend
    if(edysend < 100) {
       defaultEnd=Calendar.getInstance();
       defaultEnd.set(2010,0,0);
       edysend=(defaultEnd.getTime()).getTime();
    }         

    //    String Stat=(String)inport.receive();
    //    it should be converted to event data
    //    for now, read it from the web server
      String Stat = readHTTPfile(StatFileURL); 
  
      //      System.out.println(Stat);


      int idx = Stat.indexOf("9999");
      if(idx>-1) last=true;

      System.out.println("---->last is "+last); 

      StringTokenizer st = new StringTokenizer(Stat);
      if(st.countTokens()>9){
        endEvent = Calendar.getInstance();
        startEvent = Calendar.getInstance();
        dayOne = Calendar.getInstance(); 
        dayOne.set(1997,0,0);
        dayOneTime = (dayOne.getTime()).getTime();
        try{
        endEvent.set(
        Integer.parseInt((String)st.nextElement()),
        Integer.parseInt((String)st.nextElement())-1,
        Integer.parseInt((String)st.nextElement())+1,
        Integer.parseInt((String)st.nextElement()),
	Integer.parseInt((String)st.nextElement()));

        if(!last) {
           startEvent.set(
           Integer.parseInt((String)st.nextElement()),
           Integer.parseInt((String)st.nextElement())-1,
           Integer.parseInt((String)st.nextElement()),
           Integer.parseInt((String)st.nextElement()),
	   Integer.parseInt((String)st.nextElement()));
	}
	} catch (Exception e) {
           System.out.println("parse exception "+e.toString()); 
           System.out.println("Ooops: wrong contents of lms_stat.dat "+Stat);
	} 
        
        int y = endEvent.get(Calendar.YEAR);
        if(y==1111) {
         start=true;
         y = startEvent.get(Calendar.YEAR);
         endEvent.set(y,0,0);
         dayOne.set(y,0,0);
         dayOneTime = (dayOne.getTime()).getTime();
	}  
        long ebegin = (endEvent.getTime()).getTime();

        long eend = 1000000;
        if(last) {
	    eend = edysend+48*3600000; //add two additional days
	}
        else { 
           eend   = (startEvent.getTime()).getTime();
	}
        System.out.println(dayOneTime+" "+ebegin+" "+edysend);

        StartDay = (int)((((ebegin-dayOneTime)/1000)/3600)/24);
        if(StartDay==0) StartDay=1;
        // should be EndDay rather than DayDiff 
        // DayDiff = (int)((((eend-ebegin)/1000)/3600)/24)+1;
        // to minimize changes I do not change the name of variable
        DayDiff = (int)((((eend-dayOneTime)/1000)/3600)/24);
        System.out.println("Edys will start on day "+StartDay);
        //System.out.println("Edys will be run for "+DayDiff+" days");
        System.out.println("Edys will stop on day "+DayDiff);

      } else {
        System.out.println("Ooops: wrong contents of lms_stat.dat "+Stat);
        System.out.println("wrong number of tokens");
        int ntokens=st.countTokens();
        System.out.println("number of tokens ="+ntokens+" X");
        for(int itoken=0; itoken<ntokens; itoken++){
	    System.out.println(itoken+" "+Integer.parseInt((String)st.nextElement()));}
        System.exit(1);
      }
      String options = formatOptions(StartDay)+formatOptions(DayDiff);
      options = options+formatOptions(param3)+formatOptions(param4);       

      writeFile(OptionsFile,options);
      return start;
    }

	String formatOptions(int i) {
	  String x = Integer.toString(i);
          int len = x.length();
          int dif = 5 - len;
          if(dif > 0) {
	      switch (dif) {
              case 1 :
                       x = " "+x;
                       break;   
              case 2 :
                       x = "  "+x;
                       break;   
              case 3 :
                       x = "   "+x;
                       break;   
              case 4 :
                       x = "    "+x;
                       break;   
	      }
	  } 
          return x; 
	}   

  public String readHTTPfile(String sourceURL) {
    
    InputStream in = null;
    OutputStream out = null;
    bytes_read = 0;
    int oneread = 0;
    String stat_file="";
    byte[] buffer = new byte[4096];

    try {    
      System.out.println("ReceiveFile: "+sourceURL);
      URL url = new URL(sourceURL);
      URLConnection urlcon = url.openConnection();
      int remoteFileLength = urlcon.getContentLength();    
      System.out.println("ReceiveFile: file lenghth: "+remoteFileLength);   
      in = urlcon.getInputStream(); 
      while(bytes_read < remoteFileLength) {
              oneread = in.read(buffer);
              setBytesRead(oneread);  
        } 
      }
      catch (Exception e) {System.out.println("ReceiveFile "+e);}       
      finally {
         try{in.close();} catch (Exception e){;}
      }
      stat_file = new String(buffer);
      return stat_file; 
  }

  public void getHTTPfile(String fileName, String sourceURL) {
    
    InputStream in = null;
    OutputStream out = null;
    bytes_read = 0;
    int oneread = 0;
 
    try {    
      System.out.println("ReceiveFile: "+sourceURL);
      URL url = new URL(sourceURL);
      URLConnection urlcon = url.openConnection();
      int remoteFileLength = urlcon.getContentLength();    
      System.out.println("ReceiveFile: "+fileName+" file lenghth: "+remoteFileLength);   
      in = urlcon.getInputStream(); 
      out = new FileOutputStream(fileName);
      //System.out.println("http file is saved as "+fileName);
      byte[] buffer = new byte[4096];
       while(bytes_read < remoteFileLength) {
              oneread = in.read(buffer);
              out.write(buffer,0,oneread);
              setBytesRead(oneread);  
        } 
      }
      catch (Exception e) {System.out.println("ReceiveFile "+e);}       
      finally {
         try{in.close(); out.close();} catch (Exception e){;}
      }
  }

   public int setBytesRead(int bytes_read_) {
      bytes_read += bytes_read_;
      return bytes_read;
  }

 /** write data from "fileContent" into file with name "fileName" */
 public void  writeFile(String fileName,String fileContent)
   {
     System.out.println("I am writing the file:"+fileName+
                        " content:"+fileContent);
 
     try{
       FileOutputStream fw = new FileOutputStream(fileName);
       DataOutputStream dos = new DataOutputStream(fw);
       //write fileContent to file at once
       dos.writeBytes(fileContent);
     }catch(IOException e){
       System.out.println("There is IOException during writing file:"+e);
     }
   }

    public void sendEDY() {
    }

    void receiveEDY() {       
      String fileURL, inFileName;

      getHTTPfile(ContentsFile,ContentsFileURL);
      try {
      BufferedReader reader = new BufferedReader(new InputStreamReader
                             (new FileInputStream(ContentsFile)));
         String line;
         Vector fileList = new Vector();
         while ((line = reader.readLine()) != null) fileList.addElement(line);
        
         for(int i=0; i<fileList.size(); i++) {
           inFileName=(String)fileList.elementAt(i);
           //System.out.println(inFileName);
           if(inFileName.equals("end")) flag=false;
           else{ 
           fileURL=FileBaseURL+inFileName;
           /* strip .txt */
           itxt=inFileName.lastIndexOf(".txt");
           if(itxt>-1) {
           inFileName=inFileName.substring(0,itxt);
           }
           else {
           System.out.println("-------> no .txt extension?");
	   }
           if(inFileName.length()>1) {
             System.out.println("receiving "+inFileName);
             if(inFileName.equals("manning.edy")) inFileName="hood6.rgh";
             if(inFileName.equals("somoist.edy")) inFileName="50.ims";
             if(inFileName.equals("conduct.edy")) inFileName="hood6.ks";
             if(inFileName.equals("K.edy")) inFileName="k.map";
             if(inFileName.equals("C.edy")) inFileName="c.map";

           getHTTPfile(EdysInDir+inFileName,fileURL);
	   }
	   }
	 }
                            
      } catch (Exception e){System.out.println(e.toString());}


    }

    public void sendData() {

	// createContentsFile;
	try { 
        BufferedWriter out = new BufferedWriter(new FileWriter(OutContents));
          out.write("manning.edy.txt"); 
          out.newLine();
          out.write("somoist.edy.txt"); 
          out.newLine();
          out.write("conduct.edy.txt"); 
          out.newLine();
          out.write("K.edy.txt"); 
          out.newLine();
          out.write("C.edy.txt"); 
          out.newLine();
          out.flush();
          out.close();
	} catch (IOException e){System.out.println("IOError "+e.toString());}

          sendEDY("manning.edy.txt","hood6.rgh");
          System.out.println("send manning.edy");    
          sendEDY("somoist.edy.txt","50.ims");
          System.out.println("send somoist.edy");    
          sendEDY("conduct.edy.txt","hood6.ks");
          System.out.println("send conduct.edy");    
          sendEDY("K.edy.txt","k.map");
          System.out.println("send k.map");    
          sendEDY("C.edy.txt","c.map");
          System.out.println("send c.map");    
    }


    public void sendEDY(String CascName, String EdysName) {

	/* in spite of the name this routine does not send anything
           instead it copies a file to the Web server directory
           changing its name from EdysName to CascName */

    FileInputStream source=null;
    FileOutputStream dest=null;
      try {
        String inputFile = EdysOutDir+EdysName;
        String outputFile = OutFileBase+CascName;
        source = new FileInputStream(new File(inputFile));
        dest = new FileOutputStream(new File(outputFile));
        byte[] buffer=new byte[1024];
        while(true) {
          bytes_read = source.read(buffer);
          if(bytes_read==-1) break;
          dest.write(buffer,0,bytes_read);
        }
      } catch (Exception e) {System.out.println(e);}
        finally {
	    try {source.close();} catch (Exception e){;}
	    try {dest.close();} catch (Exception e){;}
        }   
        
    }

  /** Reading file with name "fileName" **/
  String readFile(String fileName)
   {
     System.out.println("I am reading the file:"+fileName);
 
     File file = new File(fileName);
     char[] data = null;
     try{
       FileReader in = new  FileReader(file);
       //read file char by char
       int size = (int)file.length();
       data = new char[size];
       int chars_read = 0;
       while(chars_read < size)
         chars_read += in.read(data,chars_read,size-chars_read);
     }catch(IOException e){
       System.out.println("There is IOException during reading file:"+e);
     }
 
      return new String(data);
   }
}




